/********************************************************************
* LPC-P1  LPC2106 Prototype board sample code
*
* 14.7456 Mhz crystal
* status LED connected to P0.7
*
* Copyright (c) 2003, OLIMEX Ltd.
*********************************************************************/
#include <stdio.h>
#include <string.h>
#include <inarm.h>
#include <iolpc210x.h>

#define   PLOCK       0x0400
#define   TIME        1000000

#define   LED_ON      IOCLR |= 0x00000080
#define   LED_OFF     IOSET |= 0x00000080

void Init(void);
void Delay (unsigned long a); 
void LED_blink (void);

unsigned char cntr,i;

//---------------------------------------------------------
// System initializations
//---------------------------------------------------------
void Init() {
    // Init PLL
    PLLCFG=0x23;                 // P=2, M=4, PLLfreq = 235,9296 Mhz, CCLK = 58,9824 Mhz
    PLLFEED=0xAA; PLLFEED=0x55;
    PLLCON=0x1;                 // Enable the PLL
    PLLFEED=0xAA; PLLFEED=0x55;
    while(!(PLLSTAT & PLOCK));  // Wait for PLL to lock
    PLLCON=0x3;                 // Connect PLL as clock source
    PLLFEED=0xAA; PLLFEED=0x55;   
    //Init MAM & Flash memory fetch
    MAMCR=0x2;                  //mam = flash
    MAMTIM=0x4;
    VPBDIV=0x1;                 //pclk = cclk
    //GPIO init
    IODIR=0x000000080;           //P0.7 is output(LED)
    LED_OFF;
} // Init()

void Delay (unsigned long a)
{
    while (--a!=0);
}

void LED_blink (void)
{  
      LED_OFF;                    //LED off
      Delay(TIME);
      LED_ON;                     //LED off
      Delay(TIME);            
}

//---------------------------------------------------------
// RESET entry
//---------------------------------------------------------


int main() {
    Init();                                  
    while (1) 
      {
        LED_blink ();                                                     
      }    
} //main()
